#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const ensurePrerequisites_1 = require("./ensurePrerequisites");
const getOS_1 = require("./getOS");
const help_1 = require("./help");
const link_1 = require("./link");
const readConfig_1 = require("./readConfig");
const argv = require("minimist")(process.argv.slice(2));
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        yield ensurePrerequisites_1.default();
        const operatingSystem = getOS_1.default();
        if (operatingSystem !== "unsupported") {
            const cwd = argv.config
                ? path.resolve(process.cwd(), argv.config)
                : process.cwd();
            const cmd = process.argv[2];
            if (cmd === "link" || cmd === "build") {
                const config = yield readConfig_1.default(cwd);
                if (config) {
                    link_1.default(cwd, config, cmd === "build", true, { alreadyBuilt: [], argv });
                }
                else {
                    console.log(`Missing wireman.json in ${cwd}.`);
                }
            }
            else {
                console.log(help_1.default(cmd));
            }
        }
        else {
            console.log(`Right now only Linux and OSX is supported. Pull requests are welcome.`);
        }
    });
}
main();
//# sourceMappingURL=index.js.map