"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
function readConfig(projDir) {
    return __awaiter(this, void 0, void 0, function* () {
        function toDependencyObject(dep) {
            return typeof dep === "string"
                ? (() => {
                    const depPackageJson = require(path.resolve(projDir, `../${dep}`, "package.json"));
                    return {
                        location: path.resolve(projDir, `../${dep}`),
                        name: depPackageJson.name
                    };
                })()
                : (() => {
                    const depPackageJson = require(path.resolve(projDir, `../${dep.name}`, "package.json"));
                    return {
                        location: path.resolve(projDir, `../${dep}`),
                        name: depPackageJson.name
                    };
                })();
        }
        const configPath = path.join(projDir, "wireman.json");
        const configFromFile = fs.existsSync(configPath)
            ? require(configPath)
            : { build: "./build.sh" };
        const packageJson = require(path.join(projDir, "package.json"));
        return {
            build: configFromFile.build,
            localDependencies: (configFromFile.localDependencies || []).map(toDependencyObject),
            localDevDependencies: (configFromFile.localDevDependencies || []).map(toDependencyObject),
            name: packageJson.name
        };
    });
}
exports.default = readConfig;
//# sourceMappingURL=readConfig.js.map